<?php

// +----------------------------------------------------------------------
// | JiZhiCMS { 极致CMS，给您极致的建站体验 }  
// +----------------------------------------------------------------------
// | Copyright (c) 2018-2099 http://www.jizhicms.com All rights reserved.
// +----------------------------------------------------------------------
// | Author: 留恋风 <2581047041@qq.com>
// +----------------------------------------------------------------------
// | Date：2020/05/25
// +----------------------------------------------------------------------

namespace A\exts;

use FrPHP\lib\Controller;
use FrPHP\Extend\Page;
class PluginsController extends Controller {
	
	private $tables = array();
	private $handler;
	private $config = array(
	  'host' => 'localhost',
	  'port' => 3306,
	  'user' => 'root',
	  'password' => 'root',
	  'database' => 'test',
	  'charset' => 'utf-8',
	  'target' => ''
	 );
	private $limit = 300;//每个备份文件存储的sql条数
	//自动执行
	public function _init(){
		/**
			继承系统默认配置
		
		**/
		
		//检查当前账户是否合乎操作
		if(!isset($_SESSION['admin']) || $_SESSION['admin']['id']==0){
			Redirect(U('Login/index'));
			
		}
 
	    if($_SESSION['admin']['isadmin']!=1){
			if(strpos($_SESSION['admin']['paction'],','.APP_CONTROLLER.',')!==false){
			   
			}else{
				$action = APP_CONTROLLER.'/'.APP_ACTION;
				if(strpos($_SESSION['admin']['paction'],','.$action.',')===false){
				   $ac = M('Ruler')->find(array('fc'=>$action));
				   if($this->frparam('ajax')){
					   
					   JsonReturn(['code'=>1,'msg'=>'您没有【'.$ac['name'].'】的权限！','url'=>U('Index/index')]);
				   }
				   Error('您没有【'.$ac['name'].'】的权限！',U('Index/index'));
				}
			}
		   
		  	
		}
	  	
	    $webconf = webConf();
	    $this->webconf = $webconf;
	    $customconf = get_custom();
	    $this->customconf = $customconf;
		
		//插件模板页目录
		
		$this->tpl = '@'.dirname(__FILE__).'/tpl/';
		
		/**
			在下面添加自定义操作
		**/
		
		
	}
	
	//执行SQL语句在此处处理,或者移动文件也可以在此处理
	public  function install(){
		//下面是新增test表的SQL操作
		//检测版本号
		if(!version_compare($this->webconf['web_version'],'1.8','<=') || version_compare($this->webconf['web_version'],'1.7.1','<')){
			JsonReturn(['code'=>1,'msg'=>'您的软件系统版本为'.$this->webconf['web_version'].'，该插件仅支持1.7.1-1.8版本升级！']);
		}
		//检查源码版本
		if(defined('DB_TYPE')){
			//sqlite
			$this->JZ_sqlite();
		}else{
			//mysql
			$this->JZ_mysql();
		}
		
		M('sysconfig')->update(['field'=>'web_version'],['data'=>'1.8']);
		
		//更新配置
		setCache('webconfig',null);
		setCache('customconfig',null);
		setCache('classtypetree',null);
		setCache('classtype',null);
		setCache('mobileclasstype',null);

	
		return true;
		
	}
	
	//mysql版本
	private function JZ_mysql(){
		/**
		
			数据库处理
			
		**/
		//备份数据库
		$this->JZ_backup();
		//数据库表检测
		$sql = '';
		//新增表
		$tables = $this->getTableData();
		if(!in_array(DB_PREFIX.'link_type',$tables)){
			$sql.="CREATE TABLE `".DB_PREFIX."link_type` (
				  `id` int(11) NOT NULL AUTO_INCREMENT,
				  `name` varchar(50) DEFAULT NULL,
				  `addtime` int(11) NOT NULL DEFAULT '0',
				  PRIMARY KEY (`id`)
				) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
		}
		//新增字段pid
		$fields = $this->getTableFields('member');
		if(!in_array('pid',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."member ADD pid int(11) default 0; ";
		}
		$fields = $this->getTableFields('classtype');
		if(!in_array('seo_classname',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."classtype ADD seo_classname varchar(255) default NULL; ";
		}
		//article 
		/*
		$fields = $this->getTableFields('article');
		if(!in_array('target',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."article ADD target varchar(255) default NULL; ";
		}
		if(!in_array('ownurl',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."article ADD ownurl varchar(255) default NULL; ";
		}
		//检测旧v1.6.5版本可能问题
		$fields = $this->getTableFields('buylog');
		if(!in_array('molds',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."buylog ADD molds varchar(50) default NULL; ";
		}
		if(!in_array('aid',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."buylog ADD aid int(11) default 0; ";
		}
		if(!in_array('userid',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."buylog ADD userid int(11) default 0; ";
		}
		if(!in_array('buytype',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."buylog ADD buytype varchar(20) default NULL; ";
		}
		//classtype
		$fields = $this->getTableFields('classtype');
		if(!in_array('orderstype',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."classtype ADD orderstype int(4) default 0; ";
		}
		if(!in_array('ishome',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."classtype ADD ishome tinyint(1) default 1; ";
		}
		//comment
		$fields = $this->getTableFields('comment');
		if(!in_array('reply',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."comment ADD reply TEXT default NULL; ";
		}
		//fields
		$fields = $this->getTableFields('fields');
		if(!in_array('isajax',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."fields ADD isajax tinyint(1) default 1; ";
		}
		//links
		$fields = $this->getTableFields('links');
		if(!in_array('molds',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."links ADD molds varchar(50) default 'links'; ";
		}
		if(!in_array('target',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."links ADD target varchar(255) default NULL; ";
		}
		if(!in_array('ownurl',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."links ADD ownurl varchar(255) default NULL; ";
		}
		if(!in_array('addtime',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."links ADD addtime int(11) default 0; ";
		}
		//message
		$fields = $this->getTableFields('message');
		if(!in_array('istop',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."message ADD istop tinyint(1) default 0; ";
		}
		if(!in_array('hits',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."message ADD hits int(11) default 0; ";
		}
		//page
		$fields = $this->getTableFields('page');
		if(!in_array('istop',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."page ADD istop tinyint(1) default 0; ";
		}
		if(!in_array('hits',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."page ADD hits int(11) default 0; ";
		}
		if(!in_array('addtime',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."page ADD addtime int(11) default 0; ";
		}
		//molds
		$fields = $this->getTableFields('molds');
		if(!in_array('iscontrol',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."molds ADD iscontrol tinyint(1) default 0; ";
		}
		if(!in_array('ismust',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."molds ADD ismust tinyint(1) default 1; ";
		}
		if(!in_array('isclasstype',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."molds ADD isclasstype tinyint(1) default 1; ";
		}
		if(!in_array('isshowclass',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."molds ADD isshowclass tinyint(1) default 1; ";
		}
		if(!in_array('list_html',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."molds ADD list_html varchar(50) default 'list.html'; ";
		}
		if(!in_array('details_html',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."molds ADD details_html varchar(50) default 'details.html'; ";
		}
		//product
		$fields = $this->getTableFields('product');
		if(!in_array('molds',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."product ADD molds varchar(50) default 'product'; ";
		}
		if(!in_array('target',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."product ADD target varchar(255) default NULL; ";
		}
		if(!in_array('ownurl',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."product ADD ownurl varchar(255) default NULL; ";
		}
		//tags
		$fields = $this->getTableFields('tags');
		if(!in_array('molds',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."tags ADD molds varchar(50) default 'tags'; ";
		}
		if(!in_array('ownurl',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."tags ADD ownurl varchar(255) default NULL; ";
		}
		if(!in_array('addtime',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."tags ADD addtime int(11) default 0; ";
		}
		//检查表是否存在
		$tables = $this->getTableData();
		if(!in_array(DB_PREFIX.'customurl',$tables)){
			$sql.="CREATE TABLE `".DB_PREFIX."customurl` (
				  `id` int(11) NOT NULL AUTO_INCREMENT,
				  `molds` varchar(50) DEFAULT NULL,
				  `url` varchar(255) DEFAULT NULL,
				  `tid` int(11) NOT NULL DEFAULT '0',
				  `aid` int(11) NOT NULL DEFAULT '0',
				  `addtime` int(11) NOT NULL DEFAULT '0',
				  PRIMARY KEY (`id`)
				) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
		}
		*/
		//执行SQL语句
		if($sql!=''){
			$x = M()->runSql($sql);
		}
		
		
		//更改某些数据设定
		M('ruler')->update(['fc'=>'Extmolds/index/molds/links'],['fc'=>'Links/index']);
		M('ruler')->update(['fc'=>'Extmolds/addmolds/molds/links'],['fc'=>'Links/addlinks']);
		M('ruler')->update(['fc'=>'Extmolds/editmolds/molds/links'],['fc'=>'Links/editlinks']);
		M('ruler')->update(['fc'=>'Extmolds/copymolds/molds/links'],['fc'=>'Links/copylinks']);
		M('ruler')->update(['fc'=>'Extmolds/deletemolds/molds/links'],['fc'=>'Links/deletelinks']);
		M('ruler')->update(['fc'=>'Extmolds/deleteAll/molds/links'],['fc'=>'Links/deleteAll']);
		M('ruler')->update(['fc'=>'Extmolds/changeType/molds/links'],['fc'=>'Links/changeType']);
		M('ruler')->update(['fc'=>'Extmolds/copyAll/molds/links'],['fc'=>'Links/copyAll']);
		M('ruler')->update(['fc'=>'Extmolds/editOrders/molds/links'],['fc'=>'Links/editOrders']);
		
		$adminlist = M('level_group')->findAll();
		foreach($adminlist as $v){
			$paction = str_replace([',Extmolds/index/molds/links,',',Extmolds/addmolds/molds/links,',',Extmolds/editmolds/molds/links,',',Extmolds/copymolds/molds/links,',',Extmolds/deletemolds/molds/links,',',Extmolds/deleteAll/molds/links,',',Extmolds/changeType/molds/links,',',Extmolds/copyAll/molds/links,',',Extmolds/editOrders/molds/links,'],[',Links/index,',',Links/addlinks,',',Links/editlinks,',',Links/copylinks,',',Links/deletelinks,',',Links/deleteAll,',',Links/changeType,',',Links/copyAll,',',Links/editOrders,'],$v['paction']);
			M('level_group')->update(array('id'=>$v['id']),['paction'=>$paction]);
			
		}

		//插入一些数据
		$sql='';
		if(!M('ruler')->find(['fc'=>'Links/linktype'])){
			$sql .= "INSERT INTO `".DB_PREFIX."ruler` (`name`,`fc`,`pid`,`isdesktop`,`sys`) VALUES ('友情链接分类列表','Links/linktype','77','1','1');";
		}
		if(!M('ruler')->find(['fc'=>'Links/linktypeadd'])){
			$sql .= "INSERT INTO `".DB_PREFIX."ruler` (`name`,`fc`,`pid`,`isdesktop`,`sys`) VALUES ('新增友情链接分类','Links/linktypeadd','77','1','1');";
		}
		if(!M('ruler')->find(['fc'=>'Links/linktypeedit'])){
			$sql .= "INSERT INTO `".DB_PREFIX."ruler` (`name`,`fc`,`pid`,`isdesktop`,`sys`) VALUES ('修改友情链接分类','Links/linktypeedit','77','1','1');";
		}
		if(!M('ruler')->find(['fc'=>'Links/linktypedelete'])){
			$sql .= "INSERT INTO `".DB_PREFIX."ruler` (`name`,`fc`,`pid`,`isdesktop`,`sys`) VALUES ('删除友情链接分类','Links/linktypedelete','77','1','1');";
		}
		if(!M('sysconfig')->find(['field'=>'release_table'])){
			$sql .= "INSERT INTO `".DB_PREFIX."sysconfig` (`field`,`title`,`tip`,`type`,`data`) VALUES ('release_table','允许前台发布模块', '防止数据泄露,填写允许发布模块标识,留空表示不允许发布,多个表可用|分割','0','article|product');";
		}
		
		//检查是否新增了其他扩展表
		/*
		$extmolds = M('molds')->findAll(" sys=0 and biaoshi!='links' and biaoshi!='tags' ");
		if($extmolds){
			foreach($extmolds as $v){
				if(!M('fields')->find(['molds'=>$v['biaoshi'],'field'=>'target'])){
					$sql .= "INSERT INTO `".DB_PREFIX."fields` (`field`,`molds`,`fieldname`,`tips`,`fieldtype`,`tids`,`fieldlong`,`body`,`orders`,`ismust`,`isshow`,`isadmin`,`issearch`,`islist`,`format`,`vdata`) VALUES ('target','".$v['biaoshi']."','外链URL','默认为空，系统访问内容则直接跳转到此链接','1', NULL,'255',NULL,'0','0','0','0','0','0', NULL,NULL);";
				}
				if(!M('fields')->find(['molds'=>$v['biaoshi'],'field'=>'ownurl'])){
					$sql .= "INSERT INTO `".DB_PREFIX."fields` (`field`,`molds`,`fieldname`,`tips`,`fieldtype`,`tids`,`fieldlong`,`body`,`orders`,`ismust`,`isshow`,`isadmin`,`issearch`,`islist`,`format`,`vdata`) VALUES ('ownurl','".$v['biaoshi']."','自定义URL','默认为空，自定义URL','1', NULL,'255',NULL,'0','0','0','0','0','0', NULL,NULL);";
				}
				if(!M('fields')->find(['molds'=>$v['biaoshi'],'field'=>'addtime'])){
					$sql .= "INSERT INTO `".DB_PREFIX."fields` (`field`,`molds`,`fieldname`,`tips`,`fieldtype`,`tids`,`fieldlong`,`body`,`orders`,`ismust`,`isshow`,`isadmin`,`issearch`,`islist`,`format`,`vdata`) VALUES ('addtime','".$v['biaoshi']."','添加时间','系统自带','11', NULL,'11',NULL,'0','0','0','0','0','0', 'date_2','0');";
				}
				if(!M('fields')->find(['molds'=>$v['biaoshi'],'field'=>'istop'])){
					$sql .= "INSERT INTO `".DB_PREFIX."fields` (`field`,`molds`,`fieldname`,`tips`,`fieldtype`,`tids`,`fieldlong`,`body`,`orders`,`ismust`,`isshow`,`isadmin`,`issearch`,`islist`,`format`,`vdata`) VALUES ('istop','".$v['biaoshi']."','是否置顶','系统自带','11', NULL,'2',NULL,'0','0','0','0','0','0', NULL,'0');";
				}
			}
		}
		*/
		
		
		//执行SQL语句
		if($sql!=''){
			$x = M()->runSql($sql);
		}
		/**
			文件转移
		**/
		//配置完文件
		$dir = APP_PATH.APP_HOME.'/exts/jizhicmsupdate/file/conf';
		$to = APP_PATH.'Conf';
		$this->removeFile($dir,$to);
		
		
		//系统文件
		$dir = APP_PATH.APP_HOME.'/exts/jizhicmsupdate/file/mysql';
		$from = $dir.'/frphp';
		$to = APP_PATH.'FrPHP';
		$this->removeFile($from,$to);
		$from = $dir.'/frphp/lib';
		$to = APP_PATH.'FrPHP/lib';
		$this->removeFile($from,$to);
		$from = $dir.'/frphp/extend';
		$to = APP_PATH.'FrPHP/Extend';
		$this->removeFile($from,$to);
		$from = $dir.'/frphp/common';
		$to = APP_PATH.'FrPHP/common';
		$this->removeFile($from,$to);
		$from = $dir.'/frphp/db';
		$to = APP_PATH.'FrPHP/db';
		$this->removeFile($from,$to);
		$from = $dir.'/home/ueditor';
		$to = APP_PATH.'static/common/user/uedit';
		$this->removeFile($from,$to);
		copy($from.'/AlipayServiceCheck.php',$to.'/alipay/AlipayServiceCheck.php');
		copy($from.'/WxpayH5Service.php',$to.'/wechat/WxpayH5Service.php');
		//前台文件
		//获取前台template
		$indexdata = file_get_contents(APP_PATH.'index.php');
		$r = preg_match("/define\('HOME_VIEW',[\'|\"](.*?)[\'|\"]\)/",$indexdata,$matches);
		if($r){
			$template = $matches[1];
		}else{
			$template = 'template';
		}
		
		$from = $dir.'/home/c';
		$to = APP_PATH.'Home/c';
		$this->removeFile($from,$to);
		/*
		$rr = preg_match("/define\('TPL_PATH',[\'|\"](.*?)[\'|\"]\)/",$indexdata,$matches2);
		if($rr){
			$tplpath = $matches2[1];
		}else{
			$tplpath = 'Home';
		}
		$from = $dir.'/home/tpl/user';
		$to = APP_PATH.$tplpath.'/'.$template.'/'.$this->webconf['pc_template'].'/user';
		$this->removeFile($from,$to);
		
		*/
		//后台文件
		$from = $dir.'/admin/c';
		$to = APP_PATH.'A/c';
		$this->removeFile($from,$to);
		$from = $dir.'/admin/tpl';
		$to = APP_PATH.'A/t/tpl';
		$this->removeFile($from,$to);
		//$from = $dir.'/admin/js';
		//$to = APP_PATH.'A/t/tpl/style/js';
		//$this->removeFile($from,$to);
		$from = $dir.'/admin/tpl/common';
		$to = APP_PATH.'A/t/tpl/common';
		$this->removeFile($from,$to);
		

	}
	//mysql & sqlite版本
	private function JZ_sqlite(){
		/**
		
			数据库处理
			
		**/
		//备份数据库
		if(DB_TYPE=='sqlite'){
			$r = copy(APP_PATH.DB_PATH.'/'.DB_NAME.'.db',APP_PATH.'backup/'.strtoupper(getRandChar(4)).'-'.strtoupper(getRandChar(4)).'-'.strtoupper(getRandChar(4)).'-'.strtoupper(getRandChar(4)).'-'.strtoupper(getRandChar(4)).'.db');
			
		}else{
			$this->JZ_backup();
		}
		
		
		//数据库表检测
		//article 
		$sql = '';
		//新增表
		$tables = $this->getTableData();
		if(!in_array(DB_PREFIX.'link_type',$tables)){
			$sql.="CREATE TABLE `".DB_PREFIX."link_type` (
				  `id` INTEGER PRIMARY KEY AUTOINCREMENT,
				  `name` varchar(50) DEFAULT NULL,
				  `addtime` int(11) NOT NULL DEFAULT '0'
				);";
		}
		//新增字段pid
		$fields = $this->getTableFields('member');
		if(!in_array('pid',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."member ADD pid int(11) default 0; ";
		}
		$fields = $this->getTableFields('classtype');
		if(!in_array('seo_classname',$fields)){
			$sql.= "ALTER TABLE ".DB_PREFIX."classtype ADD seo_classname varchar(255) default NULL; ";
		}
		//执行SQL语句
		if($sql!=''){
			$x = M()->runSql($sql);
		}
		
		M('ruler')->update(['fc'=>'Extmolds/index/molds/links'],['fc'=>'Links/index']);
		M('ruler')->update(['fc'=>'Extmolds/addmolds/molds/links'],['fc'=>'Links/addlinks']);
		M('ruler')->update(['fc'=>'Extmolds/editmolds/molds/links'],['fc'=>'Links/editlinks']);
		M('ruler')->update(['fc'=>'Extmolds/copymolds/molds/links'],['fc'=>'Links/copylinks']);
		M('ruler')->update(['fc'=>'Extmolds/deletemolds/molds/links'],['fc'=>'Links/deletelinks']);
		M('ruler')->update(['fc'=>'Extmolds/deleteAll/molds/links'],['fc'=>'Links/deleteAll']);
		M('ruler')->update(['fc'=>'Extmolds/changeType/molds/links'],['fc'=>'Links/changeType']);
		M('ruler')->update(['fc'=>'Extmolds/copyAll/molds/links'],['fc'=>'Links/copyAll']);
		M('ruler')->update(['fc'=>'Extmolds/editOrders/molds/links'],['fc'=>'Links/editOrders']);

		$adminlist = M('level_group')->findAll();
		foreach($adminlist as $v){
			$paction = str_replace([',Extmolds/index/molds/links,',',Extmolds/addmolds/molds/links,',',Extmolds/editmolds/molds/links,',',Extmolds/copymolds/molds/links,',',Extmolds/deletemolds/molds/links,',',Extmolds/deleteAll/molds/links,',',Extmolds/changeType/molds/links,',',Extmolds/copyAll/molds/links,',',Extmolds/editOrders/molds/links,'],[',Links/index,',',Links/addlinks,',',Links/editlinks,',',Links/copylinks,',',Links/deletelinks,',',Links/deleteAll,',',Links/changeType,',',Links/copyAll,',',Links/editOrders,'],$v['paction']);
			M('level_group')->update(array('id'=>$v['id']),['paction'=>$paction]);
			
		}
		//插入一些数据
		$sql='';
		if(!M('ruler')->find(['fc'=>'Links/linktype'])){
			$sql .= "INSERT INTO `".DB_PREFIX."ruler` (`name`,`fc`,`pid`,`isdesktop`,`sys`) VALUES ('友情链接分类列表','Links/linktype','77','1','1');";
		}
		if(!M('ruler')->find(['fc'=>'Links/linktypeadd'])){
			$sql .= "INSERT INTO `".DB_PREFIX."ruler` (`name`,`fc`,`pid`,`isdesktop`,`sys`) VALUES ('新增友情链接分类','Links/linktypeadd','77','1','1');";
		}
		if(!M('ruler')->find(['fc'=>'Links/linktypeedit'])){
			$sql .= "INSERT INTO `".DB_PREFIX."ruler` (`name`,`fc`,`pid`,`isdesktop`,`sys`) VALUES ('修改友情链接分类','Links/linktypeedit','77','1','1');";
		}
		if(!M('ruler')->find(['fc'=>'Links/linktypedelete'])){
			$sql .= "INSERT INTO `".DB_PREFIX."ruler` (`name`,`fc`,`pid`,`isdesktop`,`sys`) VALUES ('删除友情链接分类','Links/linktypedelete','77','1','1');";
		}
		if(!M('sysconfig')->find(['field'=>'release_table'])){
			$sql .= "INSERT INTO `".DB_PREFIX."sysconfig` (`field`,`title`,`tip`,`type`,`data`) VALUES ('release_table','允许前台发布模块', '防止数据泄露,填写允许发布模块标识,留空表示不允许发布,多个表可用|分割','0','article|product');";
		}
		
		//执行SQL语句
		if($sql!=''){
			$x = M()->runSql($sql);
		}
		/**
			文件转移
		**/
		//配置完文件
		$dir = APP_PATH.APP_HOME.'/exts/jizhicmsupdate/file/conf';
		$to = APP_PATH.'Conf';
		$this->removeFile($dir,$to);
		
		
		//系统文件
		$dir = APP_PATH.APP_HOME.'/exts/jizhicmsupdate/file/sqlite';
		$from = $dir.'/frphp';
		$to = APP_PATH.'FrPHP';
		$this->removeFile($from,$to);
		$from = $dir.'/frphp/lib';
		$to = APP_PATH.'FrPHP/lib';
		$this->removeFile($from,$to);
		$from = $dir.'/frphp/extend';
		$to = APP_PATH.'FrPHP/Extend';
		$this->removeFile($from,$to);
		$from = $dir.'/frphp/common';
		$to = APP_PATH.'FrPHP/common';
		$this->removeFile($from,$to);
		$from = $dir.'/frphp/db';
		$to = APP_PATH.'FrPHP/db';
		$this->removeFile($from,$to);
		$from = $dir.'/home/ueditor';
		$to = APP_PATH.'static/common/user/uedit';
		$this->removeFile($from,$to);
		copy($from.'/AlipayServiceCheck.php',$to.'/alipay/AlipayServiceCheck.php');
		copy($from.'/WxpayH5Service.php',$to.'/wechat/WxpayH5Service.php');
		//前台文件
		//获取前台template
		$indexdata = file_get_contents(APP_PATH.'index.php');
		$r = preg_match("/define\('HOME_VIEW',[\'|\"](.*?)[\'|\"]\)/",$indexdata,$matches);
		if($r){
			$template = $matches[1];
		}else{
			$template = 'template';
		}
		
		$from = $dir.'/home/c';
		$to = APP_PATH.'Home/c';
		$this->removeFile($from,$to);
		/*
		$rr = preg_match("/define\('TPL_PATH',[\'|\"](.*?)[\'|\"]\)/",$indexdata,$matches2);
		if($rr){
			$tplpath = $matches2[1];
		}else{
			$tplpath = 'Home';
		}
		$from = $dir.'/home/tpl/user';
		$to = APP_PATH.$tplpath.'/'.$template.'/'.$this->webconf['pc_template'].'/user';
		$this->removeFile($from,$to);
		*/
		
		//后台文件
		$from = $dir.'/admin/c';
		$to = APP_PATH.'A/c';
		$this->removeFile($from,$to);
		$from = $dir.'/admin/tpl';
		$to = APP_PATH.'A/t/tpl';
		$this->removeFile($from,$to);
		//$from = $dir.'/admin/js';
		//$to = APP_PATH.'A/t/tpl/style/js';
		//$this->removeFile($from,$to);
		$from = $dir.'/admin/tpl/common';
		$to = APP_PATH.'A/t/tpl/common';
		$this->removeFile($from,$to);
		

		
	}
	
	//批量转移文件
	private function removeFile($from,$to){
		//移动后台插件控制器
		$sourcefile = $from;
		$target = $to;
		if(is_dir($sourcefile) && is_dir($target)){
			if (false != ($handle = opendir ( $sourcefile ))) {
				
				while ( false !== ($file = readdir ( $handle )) ) {
					//去掉"“.”、“..”以及带“.xxx”后缀的文件
					if ($file != "." && $file != ".." && !is_dir($sourcefile.'/'.$file) ) {
						$fs = $sourcefile.'/'.$file;
						$ft = $target.'/'.$file;
						 //备份源文件以防更新覆盖
						copy($ft,  $sourcefile.'/back/'.$file);
						$r = $this->file2dir($fs,$ft);
						if(!$r){
							JsonReturn(array('code'=>1,'msg'=>'文件转移失败！sourcefile:'.$fs.' targetfile:'.$ft));
						}
					}
				}
				//关闭句柄
				closedir ( $handle );
			}
		
		}
				
	}
	
	// 原目录，复制到的目录
	function recurse_copy($src,$dst) {  
	 
		$dir = opendir($src);
		@mkdir($dst);
		while(false !== ( $file = readdir($dir)) ) {
			if (( $file != '.' ) && ( $file != '..' )) {
				if ( is_dir($src . '/' . $file) ) {
					$this->recurse_copy($src . '/' . $file,$dst . '/' . $file);
				}
				else {
					copy($src . '/' . $file,$dst . '/' . $file);
				}
			}
		}
		closedir($dir);
	}
	//复制文件并转移
	function file2dir($sourcefile, $filename){
		 if( !file_exists($sourcefile)){
			 return false;
		 }
		 //$filename = basename($sourcefile);
		
		 return copy($sourcefile,  $filename);
	}
	
	//返回表字段
	private function getTableFields($table){
		if(defined('DB_TYPE') && DB_TYPE=='sqlite'){
			$sql = "pragma table_info(".DB_PREFIX.$table.")";
			
			$list = M()->findSql($sql);
			$fields = [];
			foreach($list as $v){
				$fields[]=$v['name'];
				
			}
		}else{
			$sql = 'SHOW COLUMNS FROM '.DB_PREFIX.$table;
			$list = M()->findSql($sql);
			$isgo = true;
			$fields = [];
			foreach($list as $v){
				$fields[]=$v['Field'];
				
			}
		}
		
		
		
		return $fields;
		
	}
	//返回数据库表
	private function getTableData(){
		if(defined('DB_TYPE') && DB_TYPE=='sqlite'){
			$sql = "select name from sqlite_master where type='table' order by name";
		}else{
			$sql = "SHOW TABLES";
		}
		
		
		$tables = M()->findSql($sql);
		$ttable = array();
		foreach($tables as $value){
			foreach($value as $vv){
				$ttable[] = $vv;
			}
			
		}
		return $ttable;
	}
	
	//备份数据库
	private function JZ_backup(){
		$pconfig = array(
			'host' =>DB_HOST,
			'port' =>DB_PORT,
			'user' =>DB_USER,
			'password' =>DB_PASS,
			'database' =>DB_NAME
		);
		$this->config = array_merge($this->config, $pconfig);
		$this->handler = new \PDO("mysql:host=".$this->config['host'].";port={$this->config['port']};dbname={$this->config['database']}", $this->config['user'], $this->config['password']);
		$this->handler->query("set names utf8");
		
		$this->backup();
	}
	
	//卸载程序,对新增字段、表等进行删除SQL操作，或者其他操作
	public function uninstall(){
		//下面是删除test表的SQL操作
		
		return true;
	}
	
	//安装页面介绍,操作说明
	public function desc(){
		$this->display($this->tpl.'plugins-description.html');
	}
	
	//配置文件,插件相关账号密码等操作
	public  function setconf($plugins){
		//将插件赋值到模板中
		$this->plugins = $plugins;
		$this->config = json_decode($plugins['config'],1);
		
		$this->display($this->tpl.'plugins-body.html');
	}
	
	//获取插件内提交的数据处理
	public function setconfigdata($data){
		//ids
		
		$config = $data;

		M('plugins')->update(['id'=>$data['id']],['config'=>json_encode($config,JSON_UNESCAPED_UNICODE)]);
		setCache('hook',null);//清空hook缓存
		JsonReturn(['code'=>0,'msg'=>'设置成功！']);
	}
	
	 /**
	  * 备份
	  * @param array $tables
	  * @return bool
	  */
	 private function backup($tables = array())
	 {
	  //存储表定义语句的数组
	  $ddl = array();
	  //存储数据的数组
	  $data = array();
	  $this->setTables($tables);
	  if (!empty($this->tables))
	  {
	   foreach ($this->tables as $table)
	   {
		$ddl[] = $this->getDDL($table);
		$data[] = $this->getData($table);
	   }
	   //开始写入
	   $this->writeToFile($this->tables, $ddl, $data);
	  }
	  else
	  {
	   $this->error = '数据库中没有表!';
	   return false;
	  }
	 }
	 /**
	  * 设置要备份的表
	  * @param array $tables
	  */
	 private function setTables($tables = array())
	 {
	  if (!empty($tables) && is_array($tables))
	  {
	   //备份指定表
	   $this->tables = $tables;
	  }
	  else
	  {
	   //备份全部表
	   $this->tables = $this->getTables();
	  }
	 }
	 /**
	  * 查询
	  * @param string $sql
	  * @return mixed
	  */
	 private function query($sql = '')
	 {
	  $stmt = $this->handler->query($sql);
	  $stmt->setFetchMode(\PDO::FETCH_NUM);
	  $list = $stmt->fetchAll();
	  return $list;
	 }
	 /**
	  * 获取全部表
	  * @return array
	  */
	 private function getTables()
	 {
	  $sql = 'SHOW TABLES';
	  $list = $this->query($sql);
	  $tables = array();
	  foreach ($list as $value)
	  {
	   $tables[] = $value[0];
	  }
	  return $tables;
	 }
	 /**
	  * 获取表定义语句
	  * @param string $table
	  * @return mixed
	  */
	 private function getDDL($table = '')
	 {
	  $sql = "SHOW CREATE TABLE `{$table}`";
	  $ddl = $this->query($sql)[0][1] . ';';
	  return $ddl;
	 }
	 /**
	  * 获取表数据
	  * @param string $table
	  * @return mixed
	  */
	 private function getData($table = '')
	 {
	  $sql = "SHOW COLUMNS FROM `{$table}`";
	  $list = $this->query($sql);
	  //字段
	  $columns = '';
	  //需要返回的SQL
	  $query = [];
	  foreach ($list as $value)
	  {
	   $columns .= "`{$value[0]}`,";
	  }
	  $columns = substr($columns, 0, -1);
	  $data = $this->query("SELECT * FROM `{$table}`");
	  foreach ($data as $value)
	  {
	   $dataSql = '';
	   foreach ($value as $v)
	   {
		if($v==='' || $v===null){
		  $dataSql .= " NULL,";
		}else{
		  $dataSql .= "'{$v}',";
		}
		
	   }
	   $dataSql = substr($dataSql, 0, -1);
	   $query[]= "INSERT INTO `{$table}` ({$columns}) VALUES ({$dataSql});\r\n";
	  }
	  return $query;
	 }
	 /**
	  * 写入文件
	  * @param array $tables
	  * @param array $ddl
	  * @param array $data
	  */
	 private function writeToFile($tables = array(), $ddl = array(), $data = array())
	 {
	  $public_str = "/*\r\nMySQL Database Backup Tools\r\n";
	  $public_str .= "Server:{$this->config['host']}:{$this->config['port']}\r\n";
	  $public_str .= "Database:{$this->config['database']}\r\n";
	  $public_str .= "Data:" . date('Y-m-d H:i:s', time()) . "\r\n*/\r\n";
	  $i = 0;
	  //echo '备份数据库-'.$this->config['database'].'<br />';
	  $countsql = 0;//记录sql数
	  $filenum = 0;//文件序号
	  $backfile = $this->config['target']==''? $this->config['database'].'_'.date('Y_m_d_H_i_s').'_'.rand(100000,999999): $this->config['target'].date('YmdHis');//文件名
	  $str = $public_str."SET FOREIGN_KEY_CHECKS=0;\r\n";
	  foreach ($tables as $table)
	  {
	  // echo '备份表：'.$table.'<br>';
	   $str .= "-- ----------------------------\r\n";
	   $str .= "-- Table structure for {$table}\r\n";
	   $str .= "-- ----------------------------\r\n";
	   $str .= "DROP TABLE IF EXISTS `{$table}`;\r\n";
	   $str .= $ddl[$i] . "\r\n";
	  
	   $i++;
	   //echo '备份成功！<br/>'; 
	   
	  }
	  $i = 0;
	  foreach($tables as $table){
		//echo '备份表数据：'.$table.' <br>';
		$str .= "-- ----------------------------\r\n";
		$str .= "-- Records of {$table}\r\n";
		$str .= "-- ----------------------------\r\n";
		//$str .= $data[$i] . "\r\n";
		foreach ($data[$i] as $v){
			$str .= $v;
			$countsql++;
			if($countsql%($this->limit)==0){
				$str = '<?php die();?>'.$str;
				if($filenum==0){
					$isok = file_put_contents('backup/'.$backfile.'.php', $str);
					if(!$isok){
						JsonReturn(['code'=>1,'msg'=>'[ backup/'.$backfile.'.php ] 写入文件失败！']);
					}
					$filenum++;
				}else{
					$isok = file_put_contents('backup/'.$backfile.'_v'.$filenum.'.php', $str);
					if(!$isok){
						JsonReturn(['code'=>1,'msg'=>'[ backup/'.$backfile.'_v'.$filenum.'.php ] 写入文件失败！']);
					}
					$filenum++;
				}
				$str = $public_str;
			}	
		}
		$i++;
		
		
	  }
	  if($str!='' && $str != $public_str){
			$str = '<?php die();?>'.$str;
			if($filenum==0){
				$isok = file_put_contents('backup/'.$backfile.'.php', $str);
				if(!$isok){
					JsonReturn(['code'=>1,'msg'=>'[ backup/'.$backfile.'.php ] 写入文件失败！']);
				}
			}else{
				$isok = file_put_contents('backup/'.$backfile.'_v'.$filenum.'.php', $str);
				if(!$isok){
					JsonReturn(['code'=>1,'msg'=>'[ backup/'.$backfile.'_v'.$filenum.'.php ] 写入文件失败！']);
				}
			}
	  }

	 }
	
}




